Subject: Re: bug#51415: [PATCH] In the Artanis package the propagated input of guile-json is conflicting with guix, and no series of guix upgrades or guix installs seems to fix this. Therefore, I moved guile-json from a propagated input to an input, which solves the issue, but may not be ideal for people who don't wish to keep multiple copies of guile-json

From: Ludovic Courtès <[email-masked]>
Date: Mon, 08 Nov 2021 22:08:45 +0100

Hi,

Leo Famulari <[email-masked]> skribis:

> On Tue, Oct 26, 2021 at 07:46:02PM +0700, Blake Shaw via Guix-patches via wrote:
>> In the Artanis package the propagated input of guile-json is
>> conflicting with guix, and no series of guix upgrades or guix installs
>> seems to fix this. Therefore, I moved guile-json from a propagated
>> input to an input, which solves the issue, but may not be ideal for
>> people who don't wish to keep multiple copies of guile-json
>
> Thanks for the report... can you share the warnings or error messages
> that you are seeing?

I think the problem Blake describes is this:

--8<---------------cut here---------------start------------->8---
$ guix install artanis guix -p /tmp/test
La jenaj pakoj estos instalataj:
    artanis 0.5
   guix    1.3.0-11.014f1b6

guix install: error: profile contains conflicting entries for guile-json
guix install: error:   first entry: [email-masked] /gnu/store/lxbvzmdcv82ik37z4np3c45p11iic7qx-guile-json-4.5.2
guix install: error:    ... propagated from [email-masked]
guix install: error:   second entry: [email-masked] /gnu/store/6s765nvcy77cla92wxzwhakglzlpv362-guile-json-3.5.0
guix install: error:    ... propagated from [email-masked]
hint: Try upgrading both `guix' and `artanis', or remove one of them from the profile.
--8<---------------cut here---------------end--------------->8---

Removing Guix from that profile solves the problem:

--8<---------------cut here---------------start------------->8---
$ guix install artanis  -p /tmp/test
La jena pako estos instalata:
    artanis 0.5

La jena derivaĵo estos konstruata:
   /gnu/store/jgd870rpvgxjqnlbsnlqya0libg1107v-profile.drv

building profile with 1 package...

[...]
--8<---------------cut here---------------end--------------->8---

> It's likely that guile-json is propagated for a good reason, and that
> not propagating it would cause problems for artanis users. Maybe there
> is another way to solve the problem that you're experiencing.

Yeah, though it seems that the ‘wrap-art’ phase already does the right
thing.

Blake, could you confirm that Artanis is still usable after this change,
even when guile-json is not around in GUILE_LOAD_PATH?

Thanks,
Ludo’.